﻿using Infragistics.Win.UltraWinTree;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml.Linq;

namespace UltraTreeNodeImages
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraTree1.Override.NodeStyle = Infragistics.Win.UltraWinTree.NodeStyle.CheckBox;


            this.iterateTreeNodes(this.ultraTree1.Nodes);
            this.ultraTree1.Nodes[0].CheckedState = CheckState.Checked;
        }

        private void iterateTreeNodes(TreeNodesCollection nodes)
        {
            if(nodes.Count == 0)
            {
                return;
            }

            foreach (var node in nodes)
            {
                node.LeftImages.Add(this.imageList1.Images[0]);
                if (node.CheckedState == CheckState.Checked)
                {
                    node.LeftImages.Add(this.imageList1.Images[1]);
                }
                this.iterateTreeNodes(node.Nodes);
            }
        }

        private void ultraTree1_AfterCheck(object sender, Infragistics.Win.UltraWinTree.NodeEventArgs e)
        {
            if(e.TreeNode.CheckedState == CheckState.Checked)
            {
                if(e.TreeNode.LeftImages.Count == 1)
                {
                    e.TreeNode.LeftImages.Add(this.imageList1.Images[1]);
                }
            } else
            {
                if (e.TreeNode.LeftImages.Count == 2)
                {
                    e.TreeNode.LeftImages.RemoveAt(1);
                }
            }
        }
    }
}
